<template>
  <v-row class="ma-0">
    <v-col cols="12">
      <v-pagination
        v-if="pagination.lastPage > 1"
        class="d-inline-block"
        v-model="pagination.currentPage"
        :length="pagination.lastPage"
        :total-visible="10"
        @input="changePage"
      ></v-pagination>
      <span class="float-right"
        >Hiển thị từ {{ pagination.from }} ~ {{ pagination.to }} trong tổng số
        {{ pagination.total }} khách hàng</span
      >
    </v-col>
    <v-col cols="12">
      <v-form ref="form" v-model="valid" lazy-validation>
        <v-simple-table fixed-header height="700px">
          <template v-slot:default>
            <thead>
              <tr>
                <th class="text-center">#</th>
                <th class="text-left">Họ tên</th>
                <th class="text-left">Email</th>
                <th class="text-left">Địa chỉ</th>
                <th class="text-left">Trạng Thái</th>
                <th class="text-left">Điện thoại</th>
                <th></th>
              </tr>
            </thead>
            <tbody>
              <template v-if="items.length > 0">
                <tr v-for="(item, index) in items" :key="item.id">
                  <td class="text-center">{{ index + 1 }}</td>
                  <td>
                    <div
                      v-if="
                        !itemEditing.customerId ||
                        itemEditing.customerId !== item.customerId
                      "
                    >
                      {{ item.customerName }}
                    </div>
                    <div v-else class="mt-5">
                      <v-text-field
                        label="Tên"
                        outlined
                        dense
                        :rules="rules.customerName"
                        v-model="itemEditing.customerName"
                        @keydown.enter="onSave"
                      ></v-text-field>
                    </div>
                  </td>
                  <td>
                    <div
                      v-if="
                        !itemEditing.customerId ||
                        itemEditing.customerId !== item.customerId
                      "
                    >
                      {{ item.email }}
                    </div>
                    <div v-else class="mt-5">
                      <v-text-field
                        label="Email"
                        outlined
                        dense
                        :rules="rules.email"
                        v-model="itemEditing.email"
                        @keydown.enter="onSave"
                      ></v-text-field>
                    </div>
                  </td>
                  <td>
                    <div
                      v-if="
                        !itemEditing.customerId ||
                        itemEditing.customerId !== item.customerId
                      "
                    >
                      {{ item.address }}
                    </div>
                    <div v-else class="mt-5">
                      <v-text-field
                        label="Địa chỉ"
                        outlined
                        dense
                        :rules="rules.address"
                        v-model="itemEditing.address"
                        @keydown.enter="onSave"
                      ></v-text-field>
                    </div>
                  </td>
                  <td>
                    <div
                      v-if="
                        !itemEditing.customerId ||
                        itemEditing.customerId !== item.customerId
                      "
                    >
                      <span v-if="item.isActive" class="green--text"
                        >Đang hoạt động</span
                      >
                      <span v-else class="red--text">Tạm khóa</span>
                    </div>
                    <div v-else>
                      <v-checkbox
                        class="mt-0 pt-0"
                        hide-details
                        hide-spin-buttons
                        v-model="itemEditing.isActive"
                        :value="1"
                      ></v-checkbox>
                    </div>
                  </td>
                  <td>
                    <div
                      v-if="
                        !itemEditing.customerId ||
                        itemEditing.customerId !== item.customerId
                      "
                    >
                      {{ item.telNum }}
                    </div>
                    <div v-else class="mt-5">
                      <v-text-field
                        label="Điện thoại"
                        outlined
                        dense
                        :rules="rules.telNum"
                        v-model="itemEditing.telNum"
                        @keydown.enter="onSave"
                      ></v-text-field>
                    </div>
                  </td>
                  <td class="text-center">
                    <div
                      v-if="
                        !itemEditing.customerId ||
                        itemEditing.customerId !== item.customerId
                      "
                    >
                      <v-btn icon @click="onEdit(item)">
                        <v-icon class="light-blue--text">mdi-pencil</v-icon>
                      </v-btn>
                    </div>
                    <div v-else>
                      <v-btn icon @click="onSave()">
                        <v-icon class="green--text"
                          >mdi-content-save-check</v-icon
                        >
                      </v-btn>
                      <v-btn icon @click="onCancel()">
                        <v-icon class="red--text">mdi-close </v-icon>
                      </v-btn>
                    </div>
                  </td>
                </tr>
              </template>
              <template v-else>
                <tr>
                  <td colspan="7" class="text-center">Không có dữ liệu</td>
                </tr>
              </template>
            </tbody>
          </template>
        </v-simple-table>
      </v-form>
    </v-col>
    <v-col cols="12">
      <v-pagination
        v-if="pagination.lastPage > 1"
        class="d-inline-block"
        v-model="pagination.currentPage"
        :length="pagination.lastPage"
        :total-visible="10"
        @input="changePage"
      ></v-pagination>
    </v-col>
  </v-row>
</template>

<script>
import customerService from "../../../services/customerService";

export default {
  props: {
    customers: {
      type: Array,
      required: true,
      default: [],
    },
    pagination: {
      type: Object,
      required: true,
      default: {},
    },
  },
  data() {
    return {
      valid: false,
      items: [],
      itemEditing: {
        customerId: "",
        customerName: "",
        email: "",
        telNum: "",
        address: "",
        isActive: 1,
      },
      rules: {
        customerName: [
          (v) => {
            if (!v) return "Tên không được trống.";
            if (!!v && v.length < 5) return "Tên phải lớn hơn 5 ký tự.";
            return true;
          },
        ],
        email: [
          (v) => {
            if (!v) return "Email không được trống.";
            if (!!v && !/.+@.+\..+/.test(v))
              return "Email không đúng định dạng.";
            return true;
          },
        ],
        telNum: [
          (v) => {
            if (!v) return "Điện thoại không được để trống.";
            if (!/^([0-9\s\-\+\(\)]*)$/.test(v))
              return "Nhập không đúng định dạng điện thoại.";
            return true;
          },
        ],
        address: [
          (v) => {
            if (!v) return "Địa chỉ không được để trống.";
            return true;
          },
        ],
      },
    };
  },
  watch: {
    customers(newVal, oldVal) {
      this.items = newVal;
      this.itemEditing = {
        customerId: "",
        customerName: "",
        email: "",
        telNum: "",
        address: "",
        isActive: 1,
      };
    },
  },
  methods: {
    changePage(value) {
      this.$emit("onChangePage", {
        key: "page",
        value,
      });
    },
    onEdit(item) {
      this.itemEditing = item;
    },
    onSave() {
      const isValid = this.$refs.form.validate();
      if (!isValid) return false;

      this.$store.commit("loading", true);
      this.itemEditing.isActive = Number(this.itemEditing.isActive);
      customerService
        .update(this.itemEditing.customerId, this.itemEditing)
        .then((response) => {
          this.$store.commit("loading", false);
          this.$store.commit("showMessageSuccess", "Cập nhật thành công");
          this.changePage(this.pagination.currentPage);
        })
        .catch((error) => {
          let msgError = "";
          if (error.response.status === 422) {
            const dataErrors = error.response.data.errors;
            let errors = [];
            for (const [key, value] of Object.entries(dataErrors)) {
              errors.push(value);
            }
            msgError = errors.toString();
          } else {
            msgError = error.response.data.message;
          }
          this.$store.commit("loading", false);
          this.$store.commit("showMessageError", msgError);
        });
    },
    onCancel() {
      this.itemEditing = {
        customerId: "",
        customerName: "",
        email: "",
        telNum: "",
        address: "",
        isActive: 1,
      };
    },
  },
  created() {
  },
};
</script>
<style scoped></style>
